<?php include "rptinc/ewcommon.php"; ?>
<?php include "rptinc/ewconfig.php"; ?>
<?php include "rptinc/phprptfn.php"; ?>
<?php include "rptinc/advsecu.php"; ?>
<?php

// PHP Report Maker 1.0 - Table level configuration (Quarter Wise Report for Employee)
// Table Level Constants

define("EW_TABLE_VAR", "Quarter_Wise_Report_for_Employee", TRUE);
define("EW_TABLE_GROUP_PER_PAGE", "grpperpage", TRUE);
define("EW_TABLE_SESSION_GROUP_PER_PAGE", "Quarter_Wise_Report_for_Employee_grpperpage", TRUE);
define("EW_TABLE_START_GROUP", "start", TRUE);
define("EW_TABLE_SESSION_START_GROUP", "Quarter_Wise_Report_for_Employee_start", TRUE);
define("EW_TABLE_SESSION_SEARCH", "Quarter_Wise_Report_for_Employee_search", TRUE);
define("EW_TABLE_CHILD_USER_ID", "childuserid", TRUE);
define("EW_TABLE_SESSION_CHILD_USER_ID", "Quarter_Wise_Report_for_Employee_childuserid", TRUE);

// Table Level SQL
define("EW_TABLE_REPORT_SUMMARY_TYPE", "SUM", TRUE);
define("EW_TABLE_REPORT_COLUMN_CAPTIONS", "1st Quarter,2nd Quarter,3rd Quarter,4th Quarter", TRUE);
define("EW_TABLE_REPORT_COLUMN_NAMES", "Qtr1,Qtr2,Qtr3,Qtr4", TRUE);
define("EW_TABLE_SQL_TRANSFORM", "", TRUE);
define("EW_TABLE_SQL_FROM", "tbltimesheet INNER JOIN tblusers ON (tbltimesheet.userID = tblusers.userID)", TRUE);
$EW_TABLE_SQL_SELECT = "SELECT tblusers.fullName, Year(tbltimesheet.`date`) As Year__date, SUM(tbltimesheet.hours*IF(QUARTER(tbltimesheet.`date`)=1,1,0)) As `Qtr1`, SUM(tbltimesheet.hours*IF(QUARTER(tbltimesheet.`date`)=2,1,0)) As `Qtr2`, SUM(tbltimesheet.hours*IF(QUARTER(tbltimesheet.`date`)=3,1,0)) As `Qtr3`, SUM(tbltimesheet.hours*IF(QUARTER(tbltimesheet.`date`)=4,1,0)) As `Qtr4` FROM " . EW_TABLE_SQL_FROM;
$EW_TABLE_SQL_WHERE = "";
define("EW_TABLE_SQL_GROUPBY", "tblusers.fullName, Year(tbltimesheet.`date`)", TRUE);
define("EW_TABLE_SQL_HAVING", "", TRUE);
define("EW_TABLE_SQL_ORDERBY", "tblusers.fullName ASC, Year(tbltimesheet.`date`)", TRUE);
define("EW_TABLE_SQL_PIVOT", "", TRUE);
define("EW_TABLE_SQL_USERID_FILTER", "", TRUE);
$af_date = NULL; // Advanced filter for date
$af_hours = NULL; // Advanced filter for hours
$af_fullName = NULL; // Advanced filter for fullName
?>
<?php
$sExport = @$PHP_GET["export"]; // Load export request
if ($sExport == "html") {

	// Printer friendly
}
if ($sExport == "excel") {
	header('Content-Type: application/vnd.ms-excel');
	header('Content-Disposition: attachment; filename=' . EW_TABLE_VAR .'.xls');
}
if ($sExport == "word") {
	header('Content-Type: application/vnd.ms-word');
	header('Content-Disposition: attachment; filename=' . EW_TABLE_VAR .'.doc');
}
?>
<?php
$EW_FIELD_FULLNAME_SQL_SELECT = "SELECT DISTINCT tblusers.fullName FROM " . EW_TABLE_SQL_FROM;
define("EW_FIELD_FULLNAME_SQL_ORDERBY", "tblusers.fullName", TRUE);
?>
<?php
define("EW_TABLE_YEAR_SQL", "SELECT DISTINCT Year(tbltimesheet.`date`) AS Year__date FROM tbltimesheet INNER JOIN tblusers ON (tbltimesheet.userID = tblusers.userID) ORDER BY Year(tbltimesheet.`date`)", TRUE);
?>
<?php

// Initialize common variables
// Paging variables

$nRecCount = 0; // Record Count
$nStartGrp = 0; // Start Group
$nStopGrp = 0; // Stop Group
$nTotalGrps = 0; // Total Groups
$nGrpCount = 0; // Group Count
$nDisplayGrps = 3; // Groups per page
$nGrpRange = 10;

// Static group variables
$x_fullName = NULL;
$ox_fullName = NULL;
$tx_fullName = NULL;
$gx_fullName = NULL;
$ftx_fullName = 200;
$rf_fullName = NULL;
$rt_fullName = NULL;

// Column variables
$ftx_date = 133;
$rf_date = NULL;
$rt_date = NULL;
$ftx_Year__date = 3;
?>
<?php

// Open connection to the database
$conn = php_connect(HOST, USER, PASS, DB, PORT);

// Filter
$sFilter = "";
$bFilterApplied = FALSE;

// Reset
ResetCmd();

// Set up groups per page dynamically
SetUpDisplayGrps();

// Popup selected values
$sel_fullName = "";
$yr_Year__date = NULL;

// Setup selection
SetupSelection();

// Load columns to array
GetColumns();

// Add year filter
if ($yr_Year__date <> "") {
	if ($sFilter <> "") $sFilter .= " AND ";
	$sFilter .= "Year(tbltimesheet.`date`) = " . $yr_Year__date;
}

// Default Filter, Sort
$defaultFilter = ""; // Default filter string
$defaultSort = ""; // default sort string
if ($defaultFilter <> "") {
	if ($sFilter <> "") $sFilter .= " AND ";
	$sFilter .= $defaultFilter;
}

// Build sql
$sSql = ew_BuildReportSql(EW_TABLE_SQL_TRANSFORM, $EW_TABLE_SQL_SELECT, $EW_TABLE_SQL_WHERE, EW_TABLE_SQL_GROUPBY, "", EW_TABLE_SQL_ORDERBY, EW_TABLE_SQL_PIVOT, $sFilter, @$sSort);

// Load recordset
$rs = ew_LoadRs($sSql);
$rscnt = count($rs);
$row = FALSE;
$rsidx = 0;

// Set up total group count and distinct values
$val_fullName = NULL;
InitReportData($rs);
if ($nDisplayGrps <= 0) { // Display All Records
	$nDisplayGrps = $nTotalGrps;
}
$nStartGrp = 1;
SetUpStartGroup(); // Set Up Start Group Position
?>
<?php include "rptinc/header.php"; ?>
<?php if (@$sExport == "") { ?>
<script language="JavaScript" src="rptjs/x/x_core.js" type="text/javascript"></script>
<script language="JavaScript" src="rptjs/x/x_event.js" type="text/javascript"></script>
<script language="JavaScript" src="rptjs/x/x_drag.js" type="text/javascript"></script>
<script language="JavaScript" src="rptjs/popup.js" type="text/javascript"></script>
<script language="JavaScript" src="rptjs/ewrptpop.js" type="text/javascript"></script>
<script language="JavaScript" src="rptjs/swfobject.js" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">
<!--
var EW_POPUP_ALL = "(All)";
var EW_POPUP_OK = "  OK  ";
var EW_POPUP_CANCEL = "Cancel";
var EW_POPUP_FROM = "From";
var EW_POPUP_TO = "To";
var EW_POPUP_PLEASE_SELECT = "Please Select";
var EW_POPUP_NO_VALUE = "No value selected!";
var EW_POPUP_CLASSNAME = "phpreportmaker";

// popup fields
<?php $jsdata = ew_GetJsData("Quarter_Wise_Report_for_EmployeefullName", $val_fullName, $ftx_fullName); ?>
ew_CreatePopup("Quarter_Wise_Report_for_EmployeefullName", [<?php echo $jsdata; ?>]);

//-->
</script>
<div id="Quarter_Wise_Report_for_EmployeefullName_Popup" class="ewPopup">
<span class="phpreportmaker"></span>
</div>
<!-- Table container (begin) -->
<table id="ewContainer" cellspacing="0" cellpadding="0" border="0">
<!-- Top container (begin) -->
<tr><td colspan="3" class="ewPadding"><div id="ewTop" class="phpreportmaker">
<!-- top slot -->
<a name="top"></a>
<?php } ?>
Quarter Wise Report For Employee
<?php if (@$sExport == "") { ?>
&nbsp;&nbsp;<a href="Quarter_Wise_Report_for_Employeectb.php?export=html">Printer Friendly</a>
&nbsp;&nbsp;<a href="Quarter_Wise_Report_for_Employeectb.php?export=excel">Export to Excel</a>
&nbsp;&nbsp;<a href="Quarter_Wise_Report_for_Employeectb.php?export=word">Export to Word</a>
<?php if ($bFilterApplied) { ?>
&nbsp;&nbsp;<a href="Quarter_Wise_Report_for_Employeectb.php?cmd=reset">Reset All Filters</a>
<?php } ?>
<?php } ?>
<br><br>
<?php if (@$sExport == "") { ?>
</div></td></tr>
<!-- Top container (end) -->
<tr>
	<!-- Left container (begin) -->
	<td valign="top"><div id="ewLeft" class="phpreportmaker">
	<!-- left slot -->
	</div></td>
	<!-- Left container (end) -->
	<!-- Center container (report) (begin) -->
	<td valign="top" class="ewPadding"><div id="ewCenter" class="phpreportmaker">
	<!-- center slot -->
<?php } ?>
<!-- crosstab report starts -->
<div id="report_crosstab">
<?php if (@$sExport == "") { ?>
<form>
<table>
<!-- Year selection -->
<tr><td><span class="phpreportmaker">Year</span></td><td><span class="phpreportmaker">
<select name="Year__date" onchange="this.form.submit();">
<?php

// Set up array
if (is_array($val_Year__date)) {
	for ($yearIdx = 0; $yearIdx < count($val_Year__date); $yearIdx++) {
		$yearValue = $val_Year__date[$yearIdx];
		if (strval($yearValue."") == strval($yr_Year__date."")) {
			$yearSelected = " selected";
		} else {
			$yearSelected = "";
		}
?>
<option value="<?php echo $yearValue; ?>"<?php echo $yearSelected; ?>><?php echo $yearValue; ?></option>
<?php
	}
}
?>
</select>
</span></td></tr>
</table>
</form>
<?php } ?>
<?php if (@$sExport == "") { ?>
<form action="Quarter_Wise_Report_for_Employeectb.php" name="ewpagerform" id="ewpagerform">
<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td nowrap>
<?php
if ($nTotalGrps > 0) {
	$rsEof = ($nTotalGrps < ($nStartGrp + $nDisplayGrps));
	$PrevStart = $nStartGrp - $nDisplayGrps;
	if ($PrevStart < 1) { $PrevStart = 1; }
	$NextStart = $nStartGrp + $nDisplayGrps;
	if ($NextStart > $nTotalGrps) { $NextStart = $nStartGrp ; }
	$LastStart = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
	?>
	<table border="0" cellspacing="0" cellpadding="0"><tr><td><span class="phpreportmaker">Page&nbsp;</span></td>
<!--first page button-->
	<?php if ($nStartGrp == 1) { ?>
	<td><img src="rptimages/firstdisab.gif" alt="First" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="Quarter_Wise_Report_for_Employeectb.php?start=1"><img src="rptimages/first.gif" alt="First" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($PrevStart == $nStartGrp) { ?>
	<td><img src="rptimages/prevdisab.gif" alt="Previous" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="Quarter_Wise_Report_for_Employeectb.php?start=<?php echo $PrevStart; ?>"><img src="rptimages/prev.gif" alt="Previous" width="16" height="16" border="0"></a></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="pageno" value="<?php echo intval(($nStartGrp-1)/$nDisplayGrps+1); ?>" size="4"></td>
<!--next page button-->
	<?php if ($NextStart == $nStartGrp) { ?>
	<td><img src="rptimages/nextdisab.gif" alt="Next" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="Quarter_Wise_Report_for_Employeectb.php?start=<?php echo $NextStart; ?>"><img src="rptimages/next.gif" alt="Next" width="16" height="16" border="0"></a></td>
	<?php  } ?>
<!--last page button-->
	<?php if ($LastStart == $nStartGrp) { ?>
	<td><img src="rptimages/lastdisab.gif" alt="Last" width="16" height="16" border="0"></td>
	<?php } else { ?>
	<td><a href="Quarter_Wise_Report_for_Employeectb.php?start=<?php echo $LastStart; ?>"><img src="rptimages/last.gif" alt="Last" width="16" height="16" border="0"></a></td>
	<?php } ?>
	<td><span class="phpreportmaker">&nbsp;of <?php echo intval(($nTotalGrps-1)/$nDisplayGrps+1);?></span></td>
	</tr></table>
	<?php if ($nStartGrp > $nTotalGrps) { $nStartGrp = $nTotalGrps; }
	$nStopGrp = $nStartGrp + $nDisplayGrps - 1;
	$nGrpCount = $nTotalGrps - 1;
	if ($rsEof) { $nGrpCount = $nTotalGrps; }
	if ($nStopGrp > $nGrpCount) { $nStopGrp = $nGrpCount; } ?>
	<span class="phpreportmaker"> <?php echo $nStartGrp; ?> to <?php echo $nStopGrp; ?> of <?php echo $nTotalGrps; ?></span>
<?php } else { ?>
	<span class="phpreportmaker"></span>	
<?php } ?>
		</td>
<?php if ($nTotalGrps > 0) { ?>
		<td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td align="right" valign="top" nowrap><span class="phpreportmaker">Groups Per Page&nbsp;
<select name="<?php echo EW_TABLE_GROUP_PER_PAGE; ?>" onChange="this.form.submit();" class="phpreportmaker">
<option value="1"<?php if ($nDisplayGrps == 1) echo " selected" ?>>1</option>
<option value="2"<?php if ($nDisplayGrps == 2) echo " selected" ?>>2</option>
<option value="3"<?php if ($nDisplayGrps == 3) echo " selected" ?>>3</option>
<option value="4"<?php if ($nDisplayGrps == 4) echo " selected" ?>>4</option>
<option value="5"<?php if ($nDisplayGrps == 5) echo " selected" ?>>5</option>
<option value="10"<?php if ($nDisplayGrps == 10) echo " selected" ?>>10</option>
<option value="20"<?php if ($nDisplayGrps == 20) echo " selected" ?>>20</option>
<option value="50"<?php if ($nDisplayGrps == 50) echo " selected" ?>>50</option>
<option value="ALL"<?php if (@$PHP_SESSION[EW_TABLE_SESSION_GROUP_PER_PAGE] == -1) echo " selected" ?>>All Records</option>
</select>
		</span></td>
<?php } ?>
	</tr>
</table>
</form>
<?php } ?>
<!-- Report grid (begin) -->
<table id="ewReport" class="ewTable">
	<!-- Table header -->
	<tr class="ewTableRow">
		<td colspan="1" nowrap><div class="phpreportmaker">hours (SUM)&nbsp;</div></td>
		<td class="ewRptColHeader" colspan="<?php echo @$ncolspan; ?>" nowrap>
			date
		</td>
	</tr>
	<tr>
		<td class="ewRptGrpHeader1">
			full Name
<?php if (@$sExport == "") { ?>
			<a href="#" onClick="ew_ShowPopup(this.name, 'Quarter_Wise_Report_for_EmployeefullName', false, '<?php echo $rf_fullName; ?>', '<?php echo $rt_fullName; ?>');return false;" name="x_fullName" id="x_fullName"><img src="rptimages/popup.gif" width="15" height="14" align="texttop" border="0" alt=""></a>
<?php } ?>
		</td>
<!-- Dynamic columns begin -->
	<?php
	for ($iy = 1; $iy < count($val); $iy++) {
		if ($col[$iy][2]) {
			$x_date = $col[$iy][1];
	?>
		<td class="ewTableHeader" valign="top">
<?php echo $x_date ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
		<?php $x_date = "Total"; ?>
		<td class="ewTableHeader" valign="top">
<?php echo $x_date ?>
</td>
	</tr>
<?php
if ($nTotalGrps > 0) {

// Start group <= total number of groups
if (intval($nStartGrp) > intval($nTotalGrps)) {
	$nStartGrp = $nTotalGrps;
}

// Set the last group to display
$nStopGrp = $nStartGrp + $nDisplayGrps - 1;

// Stop group <= total number of groups
if (intval($nStopGrp) > intval($nTotalGrps)) {
	$nStopGrp = $nTotalGrps;
}

// navigate
$grpvalue = "";
$nRecCount = 0;

// Get first row
if ($rscnt > 0) {
	GetRow(1);
	$nGrpCount = 1;
}
while ($row) {

	// Process groups
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
		$nRecCount++;

		// Set row color
		$sItemRowClass = " class=\"ewTableRow\"";

		// Display alternate color for rows
		if ($nRecCount % 2 <> 1) {
			$sItemRowClass = " class=\"ewTableAltRow\"";
		}

		// Show group values
		$gx_fullName = $x_fullName;
		if ($x_fullName <> "" && $ox_fullName == $x_fullName && !ChkLvlBreak(1)) {
			$gx_fullName = "";
		} elseif ($x_fullName == NULL) {
			$gx_fullName = EW_NULL_LABEL;
		} elseif ($x_fullName == "") {
			$gx_fullName = EW_EMPTY_LABEL;
		}
?>
	<!-- Data -->
	<tr<?php echo $sItemRowClass; ?>>
		<!-- full Name -->
		<td class="ewRptGrpField1"><?php $tx_fullName = $x_fullName; $x_fullName = $gx_fullName; ?>
<?php echo $x_fullName ?>
<?php $x_fullName = $tx_fullName; ?></td>
<!-- Dynamic columns begin -->
	<?php
	$rowsmry = 0;
	for ($iy = 1; $iy < count($val); $iy++) {
		if ($col[$iy][2]) {
			$rowval = $val[$iy];
			$rowsmry = ew_SummaryValue($rowsmry, $rowval, EW_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $val[$iy];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
<?php

		// Accumulate page summary
		AccumulateSummary();
	}

	// Accumulate grand summary
	AccumulateGrandSummary();

	// Save old group values
	$ox_fullName = $x_fullName;

	// Get next record
	GetRow(2);
	if (intval($nGrpCount) >= intval($nStartGrp) && $nGrpCount <= $nStopGrp) {
?>
<?php
	}

	// Increment group count
	if (ChkLvlBreak(1)) $nGrpCount++;
}
?>
	<!-- Page Summary -->
	<tr class="ewRptPageSummary">
	<td colspan="1">Page Total</td>
<!-- Dynamic columns begin -->
	<?php
	$rowsmry = 0;
	for ($iy = 1; $iy <= $ncol; $iy++) {
		if ($col[$iy][2]) {
			$rowval = $smry[$iy][0];
			$rowsmry = ew_SummaryValue($rowsmry, $rowval, EW_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $smry[$iy][0];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
	<!-- Grand Total -->
	<tr class="ewRptGrandSummary">
	<td colspan="1">Grand Total</td>
<!-- Dynamic columns begin -->
	<?php 
	$rowsmry = 0;
	for ($iy = 1; $iy <= $ncol; $iy++) {
		if ($col[$iy][2]) {
			$rowval = $grandsmry[$iy];
			$rowsmry = ew_SummaryValue($rowsmry, $rowval, EW_TABLE_REPORT_SUMMARY_TYPE);
			$x_hours = $grandsmry[$iy];
	?>
		<!-- <?php echo $col[$iy][1]; ?> -->
		<td>
<?php echo $x_hours ?>
</td>
	<?php
		}
	}
	?>
<!-- Dynamic columns end -->
	<?php $x_hours = $rowsmry; ?>
		<td>
<?php echo $x_hours ?>
</td>
	</tr>
<?php } ?>
</table>
<br>
</div>
<!-- Crosstab report ends -->
<?php if (@$sExport == "") { ?>
	</div><br></td>
	<!-- Center container (report) (end) -->
	<!-- Right container (begin) -->
	<td valign="top"><div id="ewRight" class="phpreportmaker">
	<!-- right slot -->
	</div></td>
	<!-- Right container (end) -->
</tr>
<!-- Bottom container (begin) -->
<tr><td colspan="3"><div id="ewBottom" class="phpreportmaker">
	<!-- bottom slot -->
	</div><br></td></tr>
<!-- Bottom container (end) -->
</table>
<!-- Table container (end) -->
<?php } ?>
<?php

// Close recordset and connection
php_free_result($rs);
php_close($conn);
?>
<?php include "rptinc/footer.php"; ?>
<?php

// Get column values
function GetColumns() {
	global $EW_TABLE_SQL_SELECT, $EW_TABLE_DISTINCT_SQL_SELECT;
	global $EW_TABLE_DISTINCT_SQL_WHERE, $EW_TABLE_DISTINCT_SQL_ORDERBY;
	global $sFilter, $sSort;
	global $sel_date;	
	global $row, $ncol, $col, $val, $oval, $cnt, $smry, $grandsmry;
	global $ncolspan;
	global $val_Year__date;
	global $yr_Year__date;

	// Get distinct year
	$rsyear = ew_LoadRs(EW_TABLE_YEAR_SQL);
	foreach ($rsyear as $row) {
		if ($row[0] != NULL) $val_Year__date[] = $row[0];
	}
	php_free_result($rsyear);
	if (is_array($val_Year__date)) {
		if ($yr_Year__date == NULL || $yr_Year__date == "") {
			$yr_Year__date = $val_Year__date[0];
		}
	}
	$arColumnCaptions = explode(",", EW_TABLE_REPORT_COLUMN_CAPTIONS);
	$arColumnNames = explode(",", EW_TABLE_REPORT_COLUMN_NAMES);

	// Get distinct column count
	$ncol = count($arColumnNames);

	// 1st dimension = no of groups (level 0 used for grand total)
	// 2nd dimension = no of distinct values

	$nGrps = 1;
	$col = ew_Init2DArray($ncol+1, 2, NULL);
	$val = ew_InitArray($ncol+1, NULL);
	$oval = ew_InitArray($ncol+1, NULL);
	$cnt = ew_Init2DArray($ncol+1, $nGrps+1, NULL);
	$smry = ew_Init2DArray($ncol+1, $nGrps+1, NULL);
	$grandsmry = ew_InitArray($ncol+1, NULL);

	// Reset summary values
	ResetLevelSummary(0);
	$colcnt = 0;
	for ($colcnt = 1; $colcnt <= $ncol; $colcnt++) {
		$col[$colcnt][0] = $arColumnNames[$colcnt-1]; // value
		$col[$colcnt][1] = $arColumnCaptions[$colcnt-1];// caption
		$col[$colcnt][2] = TRUE; // column visible
	}

	// Get active columns
	if (!is_array($sel_date)) {
		$ncolspan = $ncol;
	} else {
		$ncolspan = 0;
		for ($i = 0; $i < count($col); $i++) {
			$bSelected = FALSE;
			for ($j = 0; $j < count($sel_date); $j++) {
				if (trim($sel_date[$j]) == trim($col[$i][0])) {
					$ncolspan++;
					$bSelected = TRUE;
					break;
				}
			}
			$col[$i][2] = $bSelected;
			if (!$bSelected) $bFilterApplied = TRUE;
		}
	}
	$ncolspan++; // Add summary column
}

// Get row values
function GetRow($opt) {
	global $rs, $rsidx, $row, $val, $ncol, $rscnt;
	if ($rscnt == 0) return;
	if ($opt == 1) { // Get first row
		$row = $rs[0];
	} else { // Get next row
		$rsidx++;
		$row = ($rsidx < $rscnt) ? $rs[$rsidx] : FALSE;
	}
	while ($row) {
		if (ValidRow($row)) {
			$GLOBALS["x_fullName"] = $row["fullName"];
			for ($ix = 1; $ix <= $ncol; $ix++) {
				$val[$ix] = $row[$ix+2-1];
			}
			break;
		} else {
			$rsidx++;
			$row = ($rsidx < $rscnt) ? $rs[$rsidx] : FALSE;
		}
	}
	if (!$row) {
		$GLOBALS["x_fullName"] = "";
	}
}

// Check level break
function ChkLvlBreak($lvl) {
	switch ($lvl) {
		case 1:
			return ($GLOBALS["x_fullName"] == NULL && $GLOBALS["ox_fullName"] != NULL) ||
			($GLOBALS["x_fullName"] != NULL && $GLOBALS["ox_fullName"] == NULL) ||
			($GLOBALS["x_fullName"] <> $GLOBALS["ox_fullName"]);
	}
}

// Accummulate summary
function AccumulateSummary() {
	global $val, $cnt, $smry;
	for ($ix = 1; $ix < count($smry); $ix++) {
		for ($iy = 0; $iy < count($smry[$ix]); $iy++) {
			$valwrk = $val[$ix];
			$cnt[$ix][$iy]++;
			$smry[$ix][$iy] = ew_SummaryValue($smry[$ix][$iy], $valwrk, EW_TABLE_REPORT_SUMMARY_TYPE);
		}
	}
}

// Reset level summary
function ResetLevelSummary($lvl) {

	// Clear summary values
	global $nRecCount, $cnt, $smry, $grandsmry;
	for ($ix = 1; $ix < count($smry); $ix++) {
		for ($iy = $lvl; $iy < count($smry[$ix]); $iy++) {
			$cnt[$ix][$iy] = 0;
			$smry[$ix][$iy] = 0;
		}
	}

	// Clear grand summary
	if ($lvl == 0) {
		for ($iy = 1; $iy < count($grandsmry); $iy++)
			$grandsmry[$iy] = 0;
	}

	// Reset record count
	$nRecCount = 0;
}

// Accummulate grand summary
function AccumulateGrandSummary() {
	global $val, $grandsmry;
	for ($iy = 1; $iy < count($grandsmry); $iy++) {
		$valwrk = $val[$iy];
		$grandsmry[$iy] = ew_SummaryValue($grandsmry[$iy], $valwrk, EW_TABLE_REPORT_SUMMARY_TYPE);
	}
}

//-------------------------------------------------------------------------------
// Function SetUpStartGroup
// - Set up Starting Record parameters based on Pager Navigation
// - Variables setup: nStartGrp

function SetUpStartGroup() {
	global $PHP_GET, $PHP_SESSION;
	global $nStartGrp, $nTotalGrps, $nDisplayGrps;

	// Check for a START parameter
	if (@$PHP_GET[EW_TABLE_START_GROUP] != "") {
		$nStartGrp = $PHP_GET[EW_TABLE_START_GROUP];
		$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} elseif (@$PHP_GET["pageno"] != "") {
		$nPageNo = $PHP_GET["pageno"];
		if (is_numeric($nPageNo)) {
			$nStartGrp = ($nPageNo-1)*$nDisplayGrps+1;
			if ($nStartGrp <= 0) {
				$nStartGrp = 1;
			} elseif ($nStartGrp >= intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1) {
				$nStartGrp = intval(($nTotalGrps-1)/$nDisplayGrps)*$nDisplayGrps+1;
			}
			$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
		} else {
			$nStartGrp = @$PHP_SESSION[EW_TABLE_SESSION_START_GROUP];
			if (!is_numeric($nStartGrp) || $nStartGrp == "") {
				$nStartGrp = 1; // Reset start record counter
				$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
			}
		}
	} else {
		$nStartGrp = @$PHP_SESSION[EW_TABLE_SESSION_START_GROUP];
		if (!is_numeric($nStartGrp) || $nStartGrp == "") {
			$nStartGrp = 1; // Reset start record counter
			$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
		}
	}
}

//-------------------------------------------------------------------------------
// Function ResetCmd
// - RESET: reset search parameters

function ResetCmd() {
	global $PHP_GET, $PHP_POST, $PHP_SESSION;

	// Skip if post back
	if (count($PHP_POST) > 0) return;

	// Get Reset Cmd
	if (@$PHP_GET["cmd"] != "") {
		$sCmd = $PHP_GET["cmd"];
		if (strtolower($sCmd) == "reset") {
			$PHP_SESSION["all_Quarter_Wise_Report_for_EmployeefullName"] = TRUE;
			$PHP_SESSION["sel_Quarter_Wise_Report_for_EmployeefullName"] = "";
			$PHP_SESSION["rf_Quarter_Wise_Report_for_EmployeefullName"] = "";
			$PHP_SESSION["rt_Quarter_Wise_Report_for_EmployeefullName"] = "";
			ResetPager();
		}
	}
}
function ResetPager() {
	global $PHP_SESSION, $nStartGrp;

	// Reset Start Position (Reset Command)
	$nStartGrp = 1;
	$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
}

// Set up selection
function SetupSelection() {
	global $PHP_POST, $PHP_SESSION, $PHP_GET;

	// Process post back form
	$sName = @$PHP_POST["popup"]; // Get popup form name
	$sName = (get_magic_quotes_gpc()) ? stripslashes($sName) : $sName;
	if ($sName <> "") {
		$arValues = @$PHP_POST["sel_" . $sName];
		if (is_array($arValues)) {
			if (get_magic_quotes_gpc()) array_walk($arValues, 'ew_StripSlashes');
			if (trim($arValues[0]) == "") { // select all
				@$PHP_POST["all_" . $sName] = TRUE;
				array_shift($arValues); // remove first entry
			} else {
				$PHP_SESSION["all_" . $sName] = FALSE;
			}
			$PHP_SESSION["sel_" . $sName] = $arValues;
			$PHP_SESSION["rf_" . $sName] = (get_magic_quotes_gpc()) ? stripslashes(@$PHP_POST["from_" . $sName]) : @$PHP_POST["from_" . $sName];
			$PHP_SESSION["rt_" . $sName] = (get_magic_quotes_gpc()) ? stripslashes(@$PHP_POST["to_" . $sName]) : @$PHP_POST["to_" . $sName];
			ResetPager();
		}
	}

	// Load selection criteria to array
	// Get full Name selected values

	$bSelectedAll = ew_IsSelectedAll("Quarter_Wise_Report_for_EmployeefullName");
	if (!$bSelectedAll) {
		$GLOBALS["sel_fullName"] = @$PHP_SESSION["sel_Quarter_Wise_Report_for_EmployeefullName"];
		$GLOBALS["rf_fullName"] = @$PHP_SESSION["rf_Quarter_Wise_Report_for_EmployeefullName"];
		$GLOBALS["rt_fullName"] = @$PHP_SESSION["rt_Quarter_Wise_Report_for_EmployeefullName"];
	}

	// Process query string
	if (@$PHP_GET["Year__date"] != "") {
		$GLOBALS["x_Year__date"] = $PHP_GET["Year__date"];
		if (is_numeric($GLOBALS["x_Year__date"])) {
			$PHP_SESSION["sel_Quarter_Wise_Report_for_EmployeeYear__date"] = $GLOBALS["x_Year__date"];
			ResetPager();
		}
	}
	$GLOBALS["yr_Year__date"] = @$PHP_SESSION["sel_Quarter_Wise_Report_for_EmployeeYear__date"];
}

// Initialize group data - total number of groups + grouping field arrays
function InitReportData(&$rs) {
	global $conn, $nTotalGrps, $bFilterApplied, $sFilter, $EW_TABLE_SQL_WHERE;

	// Build distinct values for full Name
	global $x_fullName, $EW_FIELD_FULLNAME_SQL_SELECT;
	$bNullValue = FALSE;
	$bEmptyValue = FALSE;
	$sSql = ew_BuildReportSql("", $EW_FIELD_FULLNAME_SQL_SELECT, $EW_TABLE_SQL_WHERE, EW_TABLE_SQL_GROUPBY, EW_TABLE_SQL_HAVING, EW_FIELD_FULLNAME_SQL_ORDERBY, "", $sFilter, "");
	$rswrk = php_query($sSql, $conn) or die("" . __LINE__ . ": " . php_error($conn) . '<br>SQL: ' . $sSql);
	while ($row = php_fetch_array($rswrk)) {
		$GLOBALS["x_fullName"] = $row[0];
		if ($GLOBALS["x_fullName"] == NULL) {
			$bNullValue = TRUE;
		} elseif ($GLOBALS["x_fullName"] == "") {
			$bEmptyValue = TRUE;
		} else {
			$GLOBALS["gx_fullName"] = $x_fullName;
			ew_SetupDistinctValues($GLOBALS["val_fullName"], $GLOBALS["x_fullName"], $GLOBALS["gx_fullName"], FALSE);
		}
	}
	php_free_result($rswrk);
	if ($bEmptyValue) ew_SetupDistinctValues($GLOBALS["val_fullName"], "##empty", EW_EMPTY_LABEL, FALSE);
	if ($bNullValue) ew_SetupDistinctValues($GLOBALS["val_fullName"], "##null", EW_NULL_LABEL, FALSE);

	// Initialize group count
	$grpcnt = 0;
	$grpvalue = "";
	foreach ($rs as $row) {
		$bValidRow = ValidRow($row);
		if (!$bValidRow) $bFilterApplied = TRUE;
		if ($bValidRow) {
			$bNewGroup = ($grpcnt == 0) ||
				($grpvalue == NULL && $row[0] != NULL) ||
				($grpvalue != NULL && $row[0] == NULL) ||
				($grpvalue <> $row[0]);
			if ($bNewGroup) {
				$grpvalue = $row[0];
				$grpcnt++;
			}
		}
	}

	// Set up total number of groups
	$nTotalGrps = $grpcnt;
}

// Check if row is valid
function ValidRow($row) {
	$ValidRow = TRUE;
	if ($ValidRow) $ValidRow = ew_SelectedValue($GLOBALS["sel_fullName"], $row["fullName"], $GLOBALS["ftx_fullName"], @$GLOBALS["af_fullName"]);
	if ($ValidRow) $ValidRow = HasColumnValues($row); // Rows with values
	return $ValidRow;
}

// Check if any column values is present
function HasColumnValues($row) {
	global $col;
	for ($i = 1; $i < count($col); $i++) {
		if ($col[$i][2]) {
			if ($row[2+$i-1] <> 0) return TRUE;
		}
	}
	return FALSE;
}
?>
<?php

//-------------------------------------------------------------------------------
// Function SetUpDisplayGrps
// - Set up Number of Groups displayed per page based on Form element GrpPerPage
// - Variables setup: nDisplayGrps

function SetUpDisplayGrps() {
	global $PHP_GET;
	global $PHP_SESSION;
	global $nDisplayGrps;
	global $nStartGrp;
	$sWrk = @$PHP_GET[EW_TABLE_GROUP_PER_PAGE];
	if ($sWrk <> "") {
		if (is_numeric($sWrk)) {
			$nDisplayGrps = intval($sWrk);
		} else {
			if (strtoupper($sWrk) == "ALL") { // Display All Records
				$nDisplayGrps = -1;
			} else {
				$nDisplayGrps = 3; // Non-numeric, Load Default
			}
		}
		$PHP_SESSION[EW_TABLE_SESSION_GROUP_PER_PAGE] = $nDisplayGrps; // Save to Session

		// Reset Start Position (Reset Command)
		$nStartGrp = 1;
		$PHP_SESSION[EW_TABLE_SESSION_START_GROUP] = $nStartGrp;
	} else {
		if (@$PHP_SESSION[EW_TABLE_SESSION_GROUP_PER_PAGE] <> "") {
			$nDisplayGrps = $PHP_SESSION[EW_TABLE_SESSION_GROUP_PER_PAGE]; // Restore from Session
		} else {
			$nDisplayGrps = 3; // Load Default
		}
	}
}
?>
